trait Observer[T] {
  def onNext(value: T)
  def onError(error: Throwable)
  def onComplete()
}

object Observer {
  def apply[T](n: T => Unit, 
               e: Throwable => Unit = throw _, 
               c: => Unit = ()) = new Observer[T] {
    def onNext(value: T) = n(value)
    def onError(error: Throwable) = e(error)
    def onComplete() = c
  }
}