import scala.concurrent.Future
import scala.concurrent.ExecutionContext.Implicits.global
import scala.annotation.tailrec

trait Scheduler {
  def schedule(work: => Unit): Subscription
  def schedule(work: (=> Unit) => Unit): Subscription
}

object Scheduler {
  def FutureScheduler = new Scheduler {
    var fut = Future.successful[Unit]()
    
    def schedule(work: => Unit): Subscription = {
      var unsubscribed = false
      fut = fut.map(_ => if (!unsubscribed) work)
      Subscription(unsubscribed = true)
    }
    
    def schedule(work: (=> Unit) => Unit): Subscription = {
      val subscription = MultipleAssignmentSubscription()      
      def loop(): Unit = {
        subscription.subscription = schedule(work(loop()))
      }
      loop()
      subscription
    }
  }
}