trait Subscription {
  def isUnsubscribed: Boolean
  def unsubscribe(): Unit
}

object Subscription {
  def apply(f: => Unit) = new Subscription {
    var isUnsubscribed = false
    def unsubscribe() = if (!isUnsubscribed) {
      isUnsubscribed = true
      f 
    }
  }
}

trait MultipleAssignmentSubscription extends Subscription {
  def subscription: Subscription
  def subscription_=(value: Subscription): Unit
}


object MultipleAssignmentSubscription {
  def apply() = new MultipleAssignmentSubscription {
    var current: Subscription = Subscription()
    var isUnsubscribed = false
    def subscription = current
    def subscription_=(value: Subscription): Unit = 
      if (isUnsubscribed) value.unsubscribe()
      else current = value
    def unsubscribe = if (!isUnsubscribed) {
      isUnsubscribed = true
      current.unsubscribe()
    }
  }
}